<script lang="ts">
  import { onDestroy } from 'svelte'
  import GiBadGnome from 'svelte-icons/gi/GiBadGnome.svelte'
  import GiDaemonSkull from 'svelte-icons/gi/GiDaemonSkull.svelte'

  import { players as playersStore, playerOneTotal, playerTwoTotal } from '../store'
  import type { PlayerT } from '../types'

  import Grid from './Grid.svelte'
  import Player from './Player.svelte'

  let playerOne: PlayerT
  let playerTwo: PlayerT

  const unsubscribeStore = playersStore.subscribe(state => {
    playerOne = state.player1
    playerTwo = state.player2
  })

  onDestroy(unsubscribeStore)
</script>

<div class="boardWrapper p-8 box-border mx-auto">
  <div class="playerSectionWrapper">
    <Player player={playerOne} total={$playerOneTotal || 0}>
      <div class="h-24" class:text-violet-600={playerOne.isPlayerTurn}>
        <GiBadGnome />
      </div>
    </Player>
    <Grid playerId={playerOne.id} grid={playerOne.grid} dice={playerOne.diceInHand} />
  </div>

  <div class="playerSectionWrapper">
    <div />
    <Grid playerId={playerTwo.id} grid={playerTwo.grid} dice={playerTwo.diceInHand} reverse={true} />
    <Player player={playerTwo} total={$playerTwoTotal || 0}>
      <div class="h-24" class:text-violet-600={playerTwo.isPlayerTurn}>
        <GiDaemonSkull />
      </div>
    </Player>
  </div>
</div>

<style>
  div.boardWrapper {
    display: flex;
    flex-direction: column-reverse;
    width: 100%;
    max-width: 1280px;
    gap: 32px;
  }

  div.playerSectionWrapper {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    align-items: center;
    justify-items: center;
  }
</style>
